#define VERSION "2020_01"
//  modif  MAJ RTC_V2  avec Js  la fin
// modif taille message eeprom  32 cars max au lieu de 64 et 6 msg

#define DIRECTORY  "C:\\_MikroC\\_MesProjets_MikroC\18F252_Msg_Defil_8_Matrices_V"
#define PROJECT "Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi"
#define SOURCE "Message_Defilant_8xMax7219_Matrices_V_18F252"
#define PROCESSOR "18F252"
#define CONFIG   "P18F252_Q_10MHz.cfgsch"
#define EEPROM "..._EEPROM.ihex"

#define POWER_SUPPLY "5V"
#define FOSC_INTERNE
#define FOSC " Q20MHz"
#define BAUD "19200"  // UART1
#define LANGAGE " Mikroc V 7.60"
//#define Timer1_LOW

#define With_UART1
// UART RC6 =TX=fil blanc   RC7= RX=fil vert  Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// librairies utilises:
// UART , C_String   C_Stdlib   Conversions , I2C
// EEPROM :

/* Config bit  :
CONFIG1H : $300001 : 0x0022
CONFIG2L : $300002 : 0x000F
CONFIG2H : $300003 : 0x000E
CONFIG3H : $300005 : 0x0001
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040



 hardware :
 RTC DS1307
 Miniinthebox 5281696500001 MAX7219 matricielle 8 * 8 en srie interfac huit chiffres
 a conduit pilote d'affichage pour Arduino #02816965   3.91 euros
 Display Matrice Leds 8x8 1088AS

  //ac:Pinout_MCU
  
   ac:Schem_8_Matrices
  
  
PIC 18F252  en PDIP 28
I2C1      SCL1 sur RC3   pin 14  ------ SCL DS1307
I2C1      SDA1 sur RC4   pin 15  ------ SDA DS1307

+5V                             ------- Pin 1  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
0V Gnd                          ------- Pin 2  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDO      RC5   pin    ------- Pin 3  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDIN     RC1   pin    not used
Select             RC0   pin   ------- Pin 4  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      CLCK     RC2   pin   ------- Pin 5  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4

UART1 TX  sur      RC6  pin 17  ------> RX  Blanc  Prolific TTL.USB ---> Ecran
UART1 RX  sur      RC7  pin 18  <------ TX  vert   Prolific TTL/USB <--- Clavier
                   RA0  pin 2
                   RA1  pin 3
                   RA2  pin 4
                   RA3  pin 5   <----- Forcage RTC par defaut
Led Rouge          RA4  pin 6    ---> Led Rouge-- R=1K --> +5V

ICSP               RB7  pin 28    ICSP Data
                   RB6  pin 27    ICSP Clock
                   MCLR pin 1   <--  ICSP VPP

                   RB5  pin 26
                   RB4  pin 25
                   RB3  pin 24
                   RB2  pin 23
                   RB1  pin 22
                   RB0  pin 21  <-- RB0 Interrupt

                   

*/

#include "built_in.h"     // for  Hi  Lo ..etc

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space
#define ON 0
#define OFF 1

#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde


#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                       // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register
#define INTENSITY_MIN     0x00                        // minimum display intensity  1/32
#define INTENSITY_MAX     0x0F                        // maximum display intensity  31/32
#define INTENSITY_MOY     0x07                        // moyenne 15/32

#define With_DS18B20

#ifdef With_DS18B20
#define OWS_DS18B20 &PORTA, 0
sbit PIN_OWS at PORTA.B0;
sbit PIN_OWS_Dir  at TRISA0_bit;
#endif


#define With_I2C1
#define RTC_DS1307
#define DS1307_ADDR 0xD0
#define DS1307 0xD0
//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RESOLUTION = 12;

sbit Debug_Time at PORTA.B3;
sbit Debug_Time_Dir  at TRISA3_bit;

sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Direction  at TRISA4_bit;
sbit  SPI_CS   at LATC.B0;
sbit  SPI_CS_direction   at TRISC0_bit;
sbit RTC_Forcee at PORTB.B1;
sbit RTC_Forcee_Dir at TRISB.B1 ;
// Software SPI module connections
sbit SoftSpi_SDI at PORTC.B1;
sbit SoftSpi_SDO at LATC.B5;
sbit SoftSpi_CLK at LATC.B2;
sbit SoftSpi_SDI_Direction at TRISC1_bit;
sbit SoftSpi_SDO_Direction at TRISC5_bit;
sbit SoftSpi_CLK_Direction at TRISC2_bit;

const code char Jour0[]="Dimanche";
const code char Jour1[]="Lundi";
const code char Jour2[]="Mardi";
const code char Jour3[]="Mercredi.";
const code char Jour4[]="Jeudi";
const code char Jour5[]="Vendredi";
const code char Jour6[]="Samedi";
const code char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6};

const code char mesg0[]=" Langage "LANGAGE"\r\n MCU : "PROCESSOR" \r\n";
const code char mesg1[]=" Directory : "DIRECTORY" \r\n";
const code char mesg2[]=" Projet : "PROJECT"\r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" Config Bits "CONFIG"\r\n";
const code char mesg5[]=" SPI1 Softw -> MAX7219, I2C1 HW -> DS1307, UART1 1900,8,N,1, OWS->DS18B20\r\n";
const code char mesg6[]=" Power Supply "POWER_SUPPLY"\r\n";
const code char mesg7[]=" EEPROM :" EEPROM"\r\n";
const code char mesg8[]=" 8 Matrices 8x8 raccordement vertical HAUT vers Bas sur MAX7129\r\n";
const code char mesg9[]=" Saisir un nouveau Msg avec le terminal via Msg=\r\n";
const code char mesg10[]=" Mode Temperature avec TEMP_ON";
const code char mesg11[]=" Joyeux NOEL 2020 ";
const code char mesg12[]=" Bonne Annee 2021 , BONNE SANTE ";
const code char mesg13[]=" xxxxxx ";

const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,
               mesg6,mesg7,mesg8,mesg9,mesg9,mesg10,mesg11,mesg12,mesg13};

#include "font_ascii_5x8_V.h"
#include "timelib.h"
// long Time_dateToEpoch(TimeStruct *ts);
// void Time_epochToDate(long e, TimeStruct *ts);
// long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);

#define MAXLEN1 128
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;

static int Flag_Timer1;
static unsigned int Cpt1;
static unsigned int Max_Timer1;
unsigned int  Flag_Timer0=0;
unsigned int   Count0=0;
int Pas=0;

int i,j,k,l,m,n;
unsigned  char TEXTE[80]; // pour teste quelconque
unsigned char TEXTE2[80]; // pour temperature Amb
unsigned char * txt;
unsigned char * txt2;
unsigned char *p1,*p2;
// MAX7129 matrice 8x8
unsigned char Aff_buffer[256];  //  8*8=64 + eventuell string terminator=0
unsigned char Speed=30;
unsigned char Rep=4;
unsigned char AnNeuf=20;

volatile struct chbits {   // 8 flags
     unsigned FrameErr:1;
     unsigned Over:1;
     unsigned Dialogue:1;
     unsigned FLT:1;
     unsigned PPS:1;
     unsigned Temper:1;
     unsigned Elapsed_Time:1;
     unsigned Mesure:1;
     unsigned First_Run:1;
   }Drapeaux ;

char CRam1[64];   // for flot2asccii use

int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long L1,L2;
unsigned char Cpt;

float f1,f2,ff;

unsigned char sec, min1, hr, week_day, day, month, year,ctrl;
unsigned char second,minute,heure,jourS,jour,mois,annee;
char  tnum[8];
int dummy;
unsigned char Date[14];     // dd/mm/20yy\0
unsigned char Time[10];      // hh:mn:ss\0
unsigned char DateTime[24];
unsigned char  DS1307_Started ;

char MinHour,MaxHour;
char Heure_En_Cours =0;
char PLM_Status=0;
unsigned int Kp;
unsigned char Repetition_Affichage_Texte=0;

TimeStruct ts1, ts2 ,ts3;
long epoch=0L ;
long epoch1=0L ;
long epoch2=0L ;
long Ecart=0L ;
unsigned char NbH=0;
unsigned char NbM=0;
unsigned char NbS=0;
char Val_Ecart[16];
char Val_epoch1[16];
char Val_epoch2[16];

 #ifdef With_DS18B20
unsigned long  DS18B20_Temp1=0L;
//unsigned
 int temp_fraction;
char temp_whole,Signe;
unsigned  int tempL=0;
unsigned   int temp=0;
#endif

unsigned char ID1[8];

 void Init_Hardware(void) ;
 void Read_Msg_Eeprom( int depuis);
 void Write_Msg_Eeprom( int Adr,const char * d1) ;
 void Read_Msg32_Eeprom(unsigned char *T, int debut) ;


 void Init_Timer1 (void);  //  timer 100mS * Max_timer1
 void Arme_Timer1(void);   //
 void Init_Timer0 (void);  //  counter in RA4 input
 void strConstRamCpy(unsigned char *dest, const code char *source);
 void UART1_Write_CText(const char *txt);
 void RAZ_UART1(void);
 unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
 void CRLF1(void)  ;

 void DS18B20_Build_value(unsigned int temp2write, char *Result);

 void Clear_Matrices(void);
 void SPI_Write_To_8x7219(unsigned char adr, unsigned char d1, unsigned char d2,unsigned char d3, unsigned char d4, unsigned char d5, unsigned char d6,unsigned char d7,unsigned char d8);
 void Affiche_Char(unsigned char c, unsigned int v);
 void Init_Module_8_Max7129_8x8(void);
 void Affiche_Text_Matrice(unsigned char *p1, unsigned int V1);
 void Affiche_CText_Matrice(const unsigned char *p2, unsigned int V2);
 void SPI_WRITE_Byte(unsigned char x);

 void Start_DS1307(void);
 void Stop_DS1307(void);
 void Init_DS1307(void);
 void MAJ_RTC(void);
 void Transform_Date_Time_To_Decimal(char  *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year);
 void Refresh_Display_Date_Time(void);
 void Write_DS1307(unsigned char addresse, unsigned char dd)  ;
//void Write_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year);
// void Read_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year);
 //void Transform_Time(char  *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year);
 void Prepare_Display_Time(char sec, char min, char hr, char week_day, char day, char monthn, char year);
 unsigned char Read_DS1307(unsigned char address) ;
 void BCD_To_Ascii(unsigned char cc,unsigned char * px);





void Interrupt_High() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
     if ((c1==CR) || (i1 > MAXLEN1-2))
      {
      Flag_Buffer1=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        if (i1 > MAXLEN1-2)  Flag_Buffer1=2;
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
      }
   }
    // comptage depassement Timer0
     if ((TMR0IE_bit) && (TMR0IF_bit) )
      {    // TXREG1='*';
         Count0++;
           OverFlow_Timer0++;
            TMR0IF_bit = 0;
       }
     // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     //TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }


void Stop_Timer0(void)
{
   Flag_Timer0=0;
   TMR0IF_bit=0;
   TMR0IE_bit=0;
   Count0=0;
   }

// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}


void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
  char c1;
  i1=Adr;
  do
  {
  c1=*d1;
  EEPROM_Write(Adr,c1);
  if ( c1==0) break;
  if ( i1>254) break;
  Delay_ms(20);
  i1++;
  }
  while (i!=0) ;
 }

void Read_Msg_Eeprom( int debut, char *Tampon)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>254) break;
  UART1_Write(i);
  Tampon[i1-debut]=i;
  Delay_ms(25);
  i1++;
   }
  while (i!=0) ;
 }

 void Read_Msg32_Eeprom(unsigned char *T, int debut)
{   int i1 ,i;
  i1=0;
  do
  {
  i = EEPROM_Read(i1+debut);
  if ( i==0) break;
  if ( i1>31) break;
  //UART1_Write(i);
  *(T+i1)=i;
  Delay_ms(1);
  i1++;
   }
  while (i!=0) ;
  *(T+i1-1)=0;
 }



 void Init_Module_8_Max7129_8x8()
 {
  SPI_CS = 0;
  Delay_ms(2);
  SPI_Write_To_8x7219(REG_DECODE, 0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00); //pas de decodage - no decode
  SPI_Write_To_8x7219(REG_INTENSITY, 0x01,0x01,0x01,0x01,0x01, 0x01,0x01, 0x01); //intensit - intensity  minima
  //scan limit registre  digit 0  7 .. les colonnes de la matrice
  SPI_Write_To_8x7219(REG_SCAN_LIMIT , 0x07, 0x07,0x07,0x07, 0x07, 0x07,0x07,0x07);
  SPI_Write_To_8x7219(REG_SHUTDOWN, 0x01, 0x01, 0x01, 0x01,0x01, 0x01, 0x01, 0x01); // normal operation
  SPI_Write_To_8x7219(REG_DISPLAY_TEST , 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00); // pas de test - no test
  Delay_ms(10);
  Clear_Matrices() ;
     SPI_CS = 1;
  Delay_ms(100);

 }
 void Delay_2uS()
 {
 _asm nop;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm nop;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
  _asm nop;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 _asm NOP;
 }



 void SPI_Write_To_8x7219(unsigned char adr, unsigned char d1, unsigned char d2,unsigned char d3, unsigned char d4, unsigned char d5, unsigned char d6,unsigned char d7, unsigned char d8)
  {
    SPI_CS = 0;
      Delay_us(50);
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d1);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d2);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d3);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d4);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d5);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d6);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d7);
  Delay_2uS();
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d8);
  Delay_2uS();
    SPI_CS = 1;
  Delay_us(10);
}


 void Clear_Matrices()
 {int i;
 for (i=0;i<8;i++)
 {
     SPI_Write_To_8x7219(i+1,0,0,0,0,0,0,0,0 ); // efface 8 afficheurs
    }
 }



 void Affiche_Char(unsigned char c, unsigned int v)
  {
   unsigned int i,j,k;
   char n;
   k=c * 8;
   n=0;
    //Aff_buffer[0]=font_8x8_V[c];
    Aff_buffer[0]=font_5x8_V[c];
    for (j = 0; j < 8; j++)
    {
       for (i = 64 ;i > 0; i--)
         {
            Aff_buffer[i] = Aff_buffer[i-1];
        }
        //   Aff_buffer[0] =font_8x8_V[j + k];
       Aff_buffer[0] =font_5x8_V[j + k];
        n = 0;
        for (i = 8; i > 0; i--)
        {
           SPI_Write_To_8x7219(i, Aff_buffer[n], Aff_buffer[n+8],Aff_buffer[n+16],
           Aff_buffer[n+24],Aff_buffer[n+32],Aff_buffer[n+40],Aff_buffer[n+48],Aff_buffer[n+56]);
           n++;
       }
     for(i=0;i<v;i++) Delay_ms(1);
    }
}



void Affiche_Text_Matrice(unsigned char *p1, unsigned int V1)
{
unsigned char c1;
    while (*(p1)>0)
     { c1=*(p1);
       Affiche_Char(c1, V1);
        p1++;
    }

}

void Affiche_CText_Matrice(const unsigned char *p2, unsigned int V2)
{
    while (*(p2)>0)
     {
       Affiche_Char(*(p2),V2);
        p2++;
    }
}

void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}

void Init_Hardware()
{
  PORTA = 0b00010011;
  ADCON1=0x07;
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3  RA4=Input  RA5,6=Digital output
  Led_Rouge_Direction=0;
  Led_Rouge=OFF;
  Debug_Time_Dir =1;
  #ifdef With_DS18B20
  PIN_OWS_Dir=1; //RA0
  #endif
  PORTB = 0xFF;
  TRISB = 0xFF;      //  ATTENTION B7 B6 for ICSP Pickit2
  RTC_Forcee_Dir=1;  // RB1 forcage RTC ;  //
  
  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  TRISC = 0xFF;  
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  // specific SPI bit bang
  SPI_CS_direction=0;
  SoftSpi_SDI_Direction=1;
  SoftSpi_SDO_Direction=0;
  SoftSpi_CLK_Direction=0;
  Delay_2uS();
  SPI_CS=1;Delay_2uS();
  SoftSpi_SDO=0; Delay_2uS();
  SoftSpi_CLK=0; Delay_2uS();

 }


void Raz_Buffer1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RCREG;
    c1=0;
    Flag_Buffer1 =0;
    RCIE_bit = 1;
    p1=0;
    GIE_bit=1;
}


void Init_Timer0(void)
{
   // init en compteur sur entree RA4
  T08BIT_bit=0; // mode 16 bits
  T0CS_bit=1;  // mode comptage sur pin T0CKI= RA4
  T0SE_bit=1; // front edge
  PSA_bit=1; //  1= Not use of prescaler => 1/1 , because, if used prescaler minimum is 1/2
  T0PS2_bit=0; // prescaler 1/2
  T0PS1_bit=0;
  T0PS0_bit=0;
  TMR0H = 0;
  TMR0L = 0;
  TMR0IP_bit=1;   // high priority
  TMR0IF_bit=0;
  TMR0IE_bit=1;
  Count0=0;
  TMR0ON_bit=0;
}

void Arme_Timer1(void)
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit= 1;
  }

void Init_Timer1(void)
 {
//FOSC=10Mhz  Prescaler 1:8; TMR1 Preload = 26473; Actual Interrupt Time : 125 ms
  T1CON         = 0x30;
  TMR1H  = 0x0B;
  TMR1L  = 0xDC;
  TMR1IF_bit         = 0;
  TMR1H         = 0x67;
  TMR1L         = 0x69;
  TMR1IE_bit         = 1;
  INTCON         = 0x40;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}


void Write_DS1307(unsigned char addresse, unsigned char dd)
{
int i;
   I2C1_Start();
   I2C1_Wr(DS1307);
   I2C1_Wr(addresse);
   I2C1_Wr(dd);
  I2C1_Stop();
 }

 unsigned char Read_DS1307(unsigned char address)
{  unsigned char dummy;
   I2C1_Start();
   I2C1_Wr(DS1307);
   I2C1_Wr(address);
   I2C1_Repeated_Start();
   I2C1_Wr(DS1307+1);           // b0 is read
   dummy=I2C1_Rd(0);         // Read with NACK.
   I2C1_Stop();
   return(dummy);
}


void Refresh_Display_Date_Time(void)
{
     sec=Read_DS1307(0);
     min1=Read_DS1307(1);
     hr =Read_DS1307(2);
     week_day=Read_DS1307(3);      // 01  07
     day=Read_DS1307(4);
     month=Read_DS1307(5);
     year=Read_DS1307(6);

      BCD_To_Ascii(hr,Time) ;   Time[2]=':';
     BCD_To_Ascii(min1,Time+3 );  Time[5]=':';
     BCD_To_Ascii(sec,Time+6);   Time[8]=0;
     BCD_To_Ascii(day,Date); Date[2]='-';
     BCD_To_Ascii(month,Date+3); Date[5]='-';
     BCD_To_Ascii(year,Date+6); Date[8]=0;
  }

 void BCD_To_Ascii(unsigned char cc,unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }



void Start_DS1307()
{
  if (DS1307_Started) return ;
   dummy = Read_DS1307(0) & ~0x80; // CH = 0 - start.
   Write_DS1307(0,dummy);
   DS1307_Started = 1;
}

void Stop_DS1307()
{
   dummy = Read_DS1307(0) | 0x80; // CH = 1 - stop.
   Write_DS1307(0,dummy);
   DS1307_Started = 0;
}

void Init_DS1307()
{
   if (Read_DS1307(0x3E)==0x20) return;  // adresse fin de RAM-1
   Start_DS1307(); // demarre oscillator
   // mode 24H
   Write_DS1307(2,Read_DS1307(2) & ~(1<<6) ); // RAZ le bit 6  pour passer en mode 24 heures.
   Write_DS1307(0,0x00 & 0x7F); // secondes
   Write_DS1307(1,0x00);  //   minutes   0-59
   Write_DS1307(2,0x20 & ~(1<<6) ); // mode 24 hour + heures
   Write_DS1307(3,0x04);  // jour de la semaine  0-6
   Write_DS1307(4,0x03);  // Date  1  31
   Write_DS1307(5,0x01);  // mois 1-12
   Write_DS1307(6,0x20);  // Annee  2020
   Write_DS1307(7,0x10); // Sortie SQW  1Hz
   Write_DS1307(0x3E,0x20);  // drapeau RTC initalise

}

void Write_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
        I2C1_Start();        // start signal
        I2C1_Wr(DS1307);     // addresse DS1307
        I2C1_Wr(0);          // start from REG 0
        I2C1_Wr(0x80+ sec);  // write $80 to REG 0. (pause counter + 0 sec)
        I2C1_Wr(min);        // write Minutes to REG 1
        I2C1_Wr(hr);         // write Heures (mode 24H) to REG 2
        I2C1_Wr(week_day);   // write jour to REG 3
        I2C1_Wr(day);        // write 27 Date to REG 4
        I2C1_Wr(month);         // write 12 Dec to REG 5
        I2C1_Wr(year);       // write 16 year to REG 6
//        I2C1_Repeated_Start();
        I2C1_Stop();         // issue stop signal
        I2C1_Start();        // issue start signal
        Delay_ms(10);
        I2C1_Wr(DS1307);     // address DS1307
        I2C1_Wr(0);          // start from word at address 0
        I2C1_Wr(0);          // write 0 to REG0 (enable counting + 0 sec)
        I2C1_Stop();         // issue stop signal
}

void Read_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
        I2C1_Start();
        I2C1_Wr(DS1307);
        I2C1_Wr(0);
        I2C1_Repeated_Start();
        I2C1_Wr(DS1307+1);
        // lecture en BCD
        *sec =I2C1_Rd(1);
        *min =I2C1_Rd(1);
        *hr =I2C1_Rd(1);
        *week_day =I2C1_Rd(1);
        *day =I2C1_Rd(1);
        *month=I2C1_Rd(1);
        *year =I2C1_Rd(0);
        I2C1_Stop();
}


void MAJ_RTC()
{
 //rev 04-01-2020
  int m,i,j,k;
  m=2; // passe par dessus "U;"
  // U;24;08;17;17;36;02#
  CRLF1();
  j=0;
  //Status=0;
  RCIE_bit = 0;
  *(buffer1+Index1)=0;
   if ((Index1<22)&&(Index1>19))
    {
      //UART1_Write_CText(" Index1 = ");
      //WordToStr(Index1,CRam1);
      //UART1_Write_Text(CRam1);
      //CRLF1();
        for (i=2;i<Index1;i++)
        {
             if(buffer1[i]==';')
              {
                buffer1[i]=0;
                DateTime[j]=atoi(buffer1+m);
                UART1_Write_Text(buffer1+m);CRLF1();
                j++;
                m=i+1;   // m=i+1;
              }
       }// for i
       // ne pas oublier le dernier item !
       DateTime[j]=atoi(buffer1+m);
       // decalage jour semaine : because use of AI2 Android application
       // ne pas oublier de remettre en ordre pour la RTC!
       k=DateTime[5];
       DateTime[5]=DateTime[4];
       DateTime[4]=DateTime[3];
       DateTime[3]=k ;
       day=DateTime[0];
       month=DateTime[1];
       year=DateTime[2];
       week_day=k; // jour de la semaine
      // WordToStr(k,CRam1);
      // UART1_Write(9);
      // UART1_Write_Text(CRam1);UART1_Write(9);
      // UART1_Write_CText(JourSemaine[ week_day]);CRLF1();
       if (week_day>6)
        {
             week_day=0;  // dimanche par defaut !
              UART1_Write_CText("\r\nErreur sur Jour Semaine jS. \r\n");
        }
        hr=DateTime[4];
        min1=DateTime[5];
        sec=0;
        Stop_DS1307();
        Write_DS1307(0,0x00); //Reset second to 0 sec. and stop Oscillator
        Write_DS1307(1,Dec2Bcd(min1)); //write min
        Write_DS1307(2,Dec2Bcd(hr)); //write hour
        Write_DS1307(3,Dec2Bcd(week_day)); //write day of week
        Write_DS1307(4,Dec2Bcd(day)); // write Date
        Write_DS1307(5,Dec2Bcd(month)); // write month
        Write_DS1307(6,Dec2Bcd(year)); // write year 2014
        Write_DS1307(7,0x10); // Sortie SQW  1Hz
        UART1_Write_CText("\r\nEcriture dans DS1307... OK\r\n");
        CRLF1();
        UART1_Write_CText("\n\r RTC UpDated \r\n");
        Start_DS1307();
        Refresh_Display_Date_Time() ;
    }
    else
    {
    UART1_Write_CText("\r\n Rappel format de cde : \"U;JJ;MM;AA;HH;MM;jD#\" \r\n");
    UART1_Write_CText(" U:03;12;19;18;36;02#  pour 03 decembre 2019  18H36 02=Mardi\r\n\r\n");
    }
 }



 void Wait_100mS()
 {
 Delay_ms(100);
 }
void   Wait_250uS(void)
{
 Delay_us(250);
 }

void DS18B20_Build_value(unsigned int temp2write, char *Result)
 {
 int jj;
 const unsigned int RES_SHIFT = TEMP_RESOLUTION - 8;
  unsigned char temp_whole;
  char Signe=0;
  unsigned int temp_fraction;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      Result[0] = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    Result[0] = ' ';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  Result[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (Result[1]=='0')Result[1]=' ';
  Result[2] =  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
   Result[3]='.';
  // Convert temp_fraction to characters
  Result[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
  Result[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
 // Result[6] = (temp_fraction/10)%10  + 48;         // Extract tens digit
  Result[6]=0;//
  //Result[7]=  temp_fraction%10      + 48;         // Extract ones digit
  Result[7]=0;//
  Result[8]=0;
  Ltrim(Result+1);
  DS18B20_Temp1= ( temp_whole *1000) +temp_fraction  ;
 }


 void Send_Cde_display_response(const char* Cde)
{  char *p2;
   Raz_Buffer1();
   p2=0;
  // UART3_Write_CText(Cde);
   strConstRamCpy(txt,Cde);
   k=strlen(txt);
   *(txt-1)=0;
   UART1_Write_Text(txt);
    Init_Timer0() ;
   while((p2==0) && (Flag_Timer0==0) )
   {
   Delay_ms(100);
   p2=strstr(buffer1,"OK");
   }
   Stop_Timer0();
   if(p2>0) Pas++;
   Delay_ms(26);  // duree maxi de reponse Version
 }

 void HC06_J_Init()
{  int N;  char ADDR[32];
  N=0;
  CRLF1();
  strConstRamCpy(CRam1,"OK");
  Send_Cde_display_response("AT\r\n");
  Send_Cde_display_response("AT+VERSION\r\n");
  Send_Cde_display_response("AT+PIN1234\r\n");
  Send_Cde_display_response("AT+NAMEHC06_8701B\r\n");
}




void main()
{


  Init_Hardware() ;
  Delay_ms(1000);
  SPI_CS=1;
  Max_Timer1=8;
  Led_Rouge=0;

  UART1_Init(19200);
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(500);

  txt=&TEXTE[0];
  txt2=&TEXTE2[0];
    TEXTE[0]=0;
   TEXTE2[0]=0;

  CRLF1();
  // presentation sur UART1
  UART1_Write_CText (" Presentation :\r\n");
  for(i=0;i<10;i++)
  {
      UART1_Write_CText(Messages[i]);
  }
  Delay_ms(2000);
  CRLF1();
  CRLF1();
  clk = Clock_kHz();
  strConstRamCpy(txt,"\r\n Clock initiale in  =  ...  Khz \r\n");
  WordToStr(clk,CRam1);
  memcpy(txt+ 23,CRam1,5);
  UART1_Write_Text(txt);

  UART1_Write_CText (" Recup Parametres en Eeeprom PIC :\r\n");
  txt=&TEXTE[0];
   //Speed=xx
   Read_Msg_Eeprom(0x0000,txt) ;  CRLF1();
   Delay_ms(20);
   Speed= (*(txt+6)-48)*10;
   Speed= Speed +  (*(txt+7)-48);

  // Rep=xx
   Read_Msg_Eeprom(0x0010,txt) ;CRLF1();
   Delay_ms(20);
   Rep= (*(txt+4)-48)*10;
   Rep= Rep +  (*(txt+5)-48);

     // PLM=18:06
   Read_Msg_Eeprom(0x0020,txt) ;CRLF1();
   Delay_ms(20);
   *(txt+6)=0;
   MaxHour=atoi(txt+4);
   *(txt+9)=0;
   MinHour=atoi(txt+7);
   Drapeaux.First_Run=1;
   Repetition_Affichage_Texte=Rep;
      // AnNeuf=21
   Read_Msg_Eeprom(0x0030,txt) ;CRLF1();
   Delay_ms(20);
   AnNeuf=(*(txt+7)-48)*10;
   AnNeuf= AnNeuf + (*(txt+8)-48);
   CRLF1();



  //============== OWS Sensor ====================================
    #ifdef With_DS18B20
   UART1_Write_CText("Test reg. DS18B20\r\n");
   Wait_100mS();
     j=0;
     Ow_Reset(OWS_DS18B20);       // Onewire reset signal
      Wait_250uS();
     Ow_Write(OWS_DS18B20, 0x33); // Read ROM (if only one device)
      Wait_250uS();
     c1=Ow_Read(OWS_DS18B20); //  123456789012345678901234567890123456789012345678
        Wait_250uS();
     UART1_Write_CText("Family Code : ");
      //  UART3_Write_CText("Family Code : ");
      *(CRam1)=0;
     ByteToHex(c1,CRam1);
     UART1_Write_Text(CRam1);
     UART1_Write_CText(" ID1= ");
     for (i=0;i<6;i++)
     {
       c1=  Ow_Read(OWS_DS18B20);
       Wait_250uS();
       ID1[i]=c1;
       *(CRam1)=0;
       ByteToHex(c1,CRam1);
       UART1_Write_Text(CRam1);
     }
     UART1_Write_CText("  CRC= ");
     c1=  Ow_Read(OWS_DS18B20); // CRC
     *(CRam1)=0;
     ByteToHex(c1,CRam1);
     UART1_Write_Text(CRam1);
     CRLF1();
  #endif
  
 // ==== MATRICES MAX7219 ===================

    UART1_Write_CText("Init SPI Software  RC2 (SCK), RC1 (SDO,) et RC0 (CS) \r\n");
     Soft_SPI_Init();
   Init_Module_8_Max7129_8x8();
   UART1_Write_CText(" Clear Matrice 8x 8x8\r\n" )  ;
   Clear_Matrices() ;
   Delay_ms(1000);


   //=========== RTC DS1307 =================

    I2C1_Init(400000);
    UART1_Write_CText("Init I2C2 (RC3=SCL et RC4=SDA )400Khz \r\n Init RTC DS1307\r\n");

  if(RTC_Forcee==0)    // RC0 input
  {
   Stop_DS1307();
   UART1_Write_CText( "init RTC par defaut 31/12/2019 23:59:00");
   Write_DS1307(0,0x50); //Reset second to 0 sec. and stop Oscillator
   Write_DS1307(1,0x59); //write min
   Write_DS1307(2,Dec2Bcd(23)); //write hour
   Write_DS1307(3,0x02); //write day of week
   Write_DS1307(4,0x31); // write Date
   Write_DS1307(5,0x12); // write month
   Write_DS1307(6,Dec2Bcd(19)); // write year 2020
   Start_DS1307();
   }
   else
   {
       UART1_Write_CText(" Re-Lecture RTC ");

   }
   CRLF1();
   Refresh_Display_Date_Time() ;
   UART1_Write_CText(" DS1307 Date : ");
   UART1_Write_Text(Date);
   UART1_Write_CText(" Time: ");
   UART1_Write_Text(Time);
   CRLF1();
   PEIE_bit=1;
   RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
   PEIE_bit = 1;          // Enable Peripheral interrupt
   GIE_bit  = 1;         // Enable Global interrupt

   Max_Timer1=8;
   CRLF1();
   Clear_Matrices() ;
  //  goto strap;

    UART1_Write_CText(" Display <01234567> sur 8 matrices Leds \r\n");
    Affiche_CText_Matrice("        ",20);
    Affiche_CText_Matrice("01234567", 40);
    Led_Rouge=~Led_Rouge;
    Delay_ms(1000);
    i=0;
    SPI_Write_To_8x7219(REG_INTENSITY,i,i,i,i,i,i,i,i);
    Delay_ms(1000);
    i=15;
    SPI_Write_To_8x7219(REG_INTENSITY,i,i,i,i,i,i,i,i);
    Delay_ms(1000);
    i=4;
     SPI_Write_To_8x7219(REG_INTENSITY,i,i,i,i,i,i,i+1,i+1);
      Delay_ms(1000);
  strap:
     Clear_Matrices() ;
     Affiche_CText_Matrice("        ", Speed);
     txt=&TEXTE[0];

    Drapeaux.Temper=1 ;
    Cpt=0;
    Speed=80;

   while (1)
    {
     GIE_bit=0;
     Init_Module_8_Max7129_8x8();
     Clear_Matrices() ;
     Affiche_CText_Matrice("        ",Speed);

      UART1_Write_CText(" Cpt= ");
     ByteToStr(Cpt,CRam1);
     UART1_Write_Text(CRam1)  ;
     CRLF1();
     

    txt2=&TEXTE2[0];
    txt=&TEXTE[0];
    Refresh_Display_Date_Time() ;
  //  Read_Date_Time(&sec,&min1,&hr,&week_day,&day,&month,&year);      // read Time from RTC(DS1307)
  //  Transform_Time(&sec,&min1,&hr,&week_day,&day,&month,&year); // format Date and Time
  //  Prepare_Display_Time( sec, min1,hr, week_day,  day, month,  year );
    ts2.ss = 00 ;
    ts2.mn = 00 ;
    ts2.hh = 00 ;
    ts2.md = 01 ;
    ts2.mo = 01 ;
    ts2.yy = (2000 +AnNeuf) ;

    ts1.ss = Bcd2Dec(sec) ;
    ts1.mn = Bcd2Dec(min1) ;
    ts1.hh = Bcd2Dec(hr) ;
    ts1.md = Bcd2Dec(day) ;
    ts1.mo = Bcd2Dec(month) ;
    ts1.yy =( 2000+ Bcd2Dec(year)) ;

    //pour debugging
   //CRLF1();  ByteToStr(AnNeuf,txt);    UART1_Write_Text(txt);    UART1_Write(TAB);
   //WordToStr(ts2.yy,txt);    UART1_Write_Text(txt);    UART1_Write(TAB);
   //WordToStr(ts1.yy,txt);    UART1_Write_Text(txt);    CRLF1();

    epoch1 = Time_dateToEpoch(&ts1) ;
    epoch2 = Time_dateToEpoch(&ts2) ;
    Ecart = Time_dateDiff(&ts1, &ts2) ;

         Ow_Reset(OWS_DS18B20);              // Onewire reset signal
         Ow_Write(OWS_DS18B20, 0xCC);       // Issue command SKIP_ROM
         Ow_Write(OWS_DS18B20, 0x44);       // Issue command CONVERT_T
         Wait_250uS();
         Ow_Reset(OWS_DS18B20);
         Ow_Write(OWS_DS18B20, 0xCC);                   // Issue command SKIP_ROM
         Ow_Write(OWS_DS18B20, 0xBE);                   // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         tempL =  Ow_Read(OWS_DS18B20);
         temp = (Ow_Read(OWS_DS18B20) << 8) + tempL;

     // pour reception de commande clavier
     Raz_Buffer1();

     if (Debug_Time==0)
    {
       UART1_Write_CText(" Date &t1 Now = ");
       Refresh_Display_Date_Time() ;
       UART1_Write_Text(Date);  UART1_Write(' ');
       UART1_Write_Text(Time); UART1_Write(' ');
       LongWordToStr(epoch1,CRam1);
       UART1_Write_Text(CRam1);
       CRLF1()  ;

       UART1_Write_CText(" Date &T2  = ");
       LongToStr(epoch2,CRam1);      // entier long sign !!
       UART1_Write_Text(CRam1);
       CRLF1()  ;

       UART1_Write_CText(" Difference = ");
       LongToStr(Ecart, Val_Ecart);
       Ltrim(Val_Ecart);
       UART1_Write_Text(Val_Ecart);
       UART1_Write_CText("  soit => ");
       WordToStr(Ecart,CRam1);
       UART1_Write_Text(CRam1);
        UART1_Write_CText(" -> ");
       k=( Ecart/3600);
       WordToStr(k,CRam1);
       UART1_Write_Text(CRam1); UART1_Write_CText(" Heures\r\n");
     }

     Delay_ms(1000);
     if ((Ecart<4) &&(Ecart> -120))
     {
          Max_Timer1=15;
          strConstRamCpy(txt2," Bonne Annee 2021 et Bonne Sante Big Bisous ");
          UART1_Write_Text(txt2);CRLF1();
          Affiche_Text_Matrice(txt2,Speed);
          Delay_ms(500);
      }
      else
      {
           if ( (Ecart>4) && (Ecart < 300) )    // 5 mn avant
           {  Speed=25;
              Max_Timer1=10;
              txt2=&TEXTE2[0];
              strConstRamCpy(txt2,">> ");
              strcat(txt2,Val_Ecart);
              strcat(txt2," Sec ");
              strcat(txt2,txt);
              Affiche_Text_Matrice(txt2, Speed);
            }
            else
            {
               if (strlen(txt2)>7)
               {
                  if (Drapeaux.First_Run==1)
                  {
                    Repetition_Affichage_Texte=Rep;
                    Drapeaux.First_Run=0;
                  }
                  if(Repetition_Affichage_Texte>0)
                  {
                   Affiche_Text_Matrice(txt2, Speed);
                   Repetition_Affichage_Texte--;
                   }
                   else *(txt2)=0;
                }
                else
                {
                Max_Timer1=15;
                txt=&TEXTE[0];
                strcpy(txt,Date);
                k=strlen(txt);
                strcat(txt+k," ");
                k=strlen(txt);
                strcat(txt+k,Time);
                DS18B20_Build_value(temp,CRam1);
                k=strlen(CRam1);
                strConstRamCpy(CRam1+k,"C ");
                UART1_Write_Text(CRam1);  CRLF1();
                k=strlen(CRam1);
                 for(i=0;i<k;i++)
                 {
                 if(*(CRam1+i)=='') *(CRam1+i)=126;
                 }
                k=strlen(txt);
                strcat(txt+k,CRam1);
                Affiche_Text_Matrice(txt, Speed);
               }
            }
       }
    Cpt++;

      // Plage Luminosite Minimale d' affichage  F (Nuit/jour)
    PLM_Status=0;
    Heure_En_Cours=(Time[0]-48)*10 + (Time[1]-48);
    if (Heure_En_Cours>=MinHour)
    {
     if (Heure_En_Cours<MaxHour) PLM_Status=1;
    }
    if (Heure_En_Cours>=0)
    {
      if (Heure_En_Cours<MinHour) PLM_Status=0;
    }
    if (PLM_Status==0)
    {
      SPI_Write_To_8x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
      }
      else
      {
       SPI_Write_To_8x7219(REG_INTENSITY, 0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02);
     }

    // test si reception de commande venant du terminal (UART1)
    if (Flag_Buffer1==1)
    {
       p1= strstr(buffer1,"Msg=");  // p1 pointer result
       if (p1>0)
       {
        k=strlen(buffer1);
        if ((k>6) && (k<84))
         {
           UART1_Write_Text("\r\n hello, i get your Msg!\r\n");
           strcpy(txt2,buffer1+4);
           Drapeaux.First_Run=1;
          }
          else
          *(txt2)=0;
        p1=0;
       }  //p
       p1= strstr(buffer1,"TEMP_ON");  // p pointer result
       if (p1>0)
       {
        Drapeaux.Temper=1;
        k=strlen(buffer1);
        UART1_Write_CText("\r\n OK, Temper is ON!\r\n");
        p1=0;
       } //p
       p1= strstr(buffer1,"TEMP_OFF");  // p1 pointer result
       if (p1>0)
       {
        Drapeaux.Temper=0;
        UART1_Write_CText("\r\n OK, Temper is OFF!\r\nRetour au display txt \r\n");
        p1=0;
       } //p
       p1= strstr(buffer1,"Speed=");  //Speed=xx
       if (p1>0)
       {
          m=0;
          if ( (isdigit(*(p1+6))) && ( isdigit(*(p1+7)) ))
          {
             m=  (*(p1+6)-48)*10;
              m= m+  (*(p1+7)-48)%10;
             if ((m>9)&&(m<100))
            {
             UART1_Write_CText(" Old speed = ");
             ByteToStr(Speed,CRam1);
             UART1_Write_Text(CRam1);CRLF1();
             Speed=m;
             EEPROM_Write(0x0006, *(p1+6));
             Delay_ms(25);
             EEPROM_Write(0x0007, *(p1+7));
             Delay_ms(25);
             UART1_Write_CText(" New ");
             Read_Msg_Eeprom(0x0000,CRam1) ;
             CRLF1();
             }
            else
            {
            UART1_Write_CText("\r\n Speed must be within 10 to 99 \r\n");
            }
          }
          else  UART1_Write_CText("\r\n BAD cde , must be: Speed=xx \r\n");
          p1=0;
         }
          p1= strstr(buffer1,"Rep=");  //Speed=xx
       if (p1>0)
       {
          m=0;
          if  ( ( isdigit(*(p1+4))) && (isdigit(*(p1+5)) ) )
          {
             m=  (*(p1+4)-48)*10;
             m= m+  (*(p1+5)-48)%10;
             if ((m>0)&&(m<11))
            {
             UART1_Write_CText(" Old Rep = ");
             ByteToStr(Rep,CRam1);
             UART1_Write_Text(CRam1);CRLF1();
             Rep=m;
             EEPROM_Write(0x0014, *(p1+4));
             Delay_ms(25);
             EEPROM_Write(0x0015, *(p1+5));
             Delay_ms(25);
             UART1_Write_CText(" New ");
             Read_Msg_Eeprom(0x0010,CRam1) ;
             CRLF1();
             }
            else
            {
            UART1_Write_CText("\r\n Rep must be within 01 to 10 \r\n");
            }
          }
          else  UART1_Write_CText("\r\n BAD cde , must be: Rep=xx \r\n");
          p1=0;
        }
       p1= strstr(buffer1,"Eeprom=");  // p1 pointer result
       if (p1>0)
       {  m=0;
          if ((isdigit(*(p1+7))))
          {
            m=  (*(p1+7)-48);
          if ((m>0)&&(m<7))
           {
              k=(m<<5)+0x020;
            //  #ifdef DEBUGGING
             UART1_Write_CText("  Eeprom Msg adresse ");
             WordToHex(k,CRam1);
              UART1_Write_Text(CRam1);CRLF1();
              //  #endif
             Read_Msg32_Eeprom(txt2,k);
            }
            else
            {
             UART1_Write_CText("\r\n Eeprom Msg adresse  must be within 1 to 7>>\r\n");
            }
          }
         p1=0;
       } //p1

       if ((buffer1[0]=='U') &&  (buffer1[19]=='#'))
       {
        // attendu :pour 02 janvier 2020 19H59 jeudi=#03
        // UART1_Write_CText("RTC MAJ au format :  U;02;01;20;19;59;03;#\r\n");
         MAJ_RTC();
          UART1_Write_CText("New DS1307 Date :");
          UART1_Write_Text(Date);
          UART1_Write_CText(" New Time: ");
          UART1_Write_Text(Time);
          CRLF1();
          *(buffer1)=0 ;
        p1=0;
      }
     p1= strstr(buffer1,"Demo");  // p pointer result
     if (p1>0)
     {
       UART1_Write_CText("Affiche 6 Messages en EEPROM modulo 32  partir de 0x0040..0x00E0 \r\n" )   ;
       for (i=1;i<5;i++)
       {
       k=i<<5;   // modulo 32
       Read_Msg32_Eeprom(txt,k);
       UART1_Write_CText("Eeprom # ");
       WordToHex(k,CRam1);UART1_Write_Text(CRam1);UART1_Write(TAB);
       UART1_Write_Text(txt);    CRLF1();
       Affiche_Text_Matrice(txt, Speed);
       Delay_ms(1000);
       }
       p1=0;
     }//p1
      p1= strstr(buffer1,"Reset");  // p pointer result
     if (p1>0)
     {
       UART1_Write_CText("Reset Afficheurs Matrice 8x8 \r\n" )   ;
        Init_Module_8_Max7129_8x8();
        UART1_Write_CText("Clear Matrice 6x 8x8\r\n" )  ;
        Clear_Matrices() ;
       Delay_ms(1000);
       p1=0;
     }//p1
      p1= strstr(buffer1,"Help");  // p1 pointer result
     if (p1>0)
     {

       UART1_Write_CText(
       "<Msg=>   L maxi=120 cars\r\n"
       "<Reset>  Re-Init afficheurs MAX7219\r\n"
       "<TEMP_ON>   Affiche la Temp. DS18B20\r\n"
       "<TEMP_OFF>  Enleve Affichage DS18B20\r\n"
       "<Speed=30>   Vitesse defilement :valeur de 10  99\r\n"
       "<Eeprom=2>   Message en eeprom de 32 cars ,avec indice 1  6\r\n"
       "<PLM=18:06> Plage Luminosit Minimale \r\n"
       "<Rep=01>   Repetition Message  01  10\r\n"
       "<AnNeuf=21> Nouvel AN = 2000+ AnNeuf 21  98\r\n"
       "<U;04;06;19;20;59;04#>  Maj de la RTC U;JJ;MM;AA;HH;MM;JS# \r\n"
       "<Demo>   affiche tous les messages en EEPROM PIC\r\n" );
       CRLF1();
       p1=0;
     }


     p1= strstr(buffer1,"AnNeuf=");
     if( (p1>0)  && (strlen(buffer1)==9))
     {
      UART1_Write_CText(" AnNeuf = ");
      Read_Msg_Eeprom(0x0030,txt) ;CRLF1();
      Delay_ms(20);
      l=isdigit(*(p1+7))+ isdigit(*(p1+8));
      if ((l>20) && (l<99))
      {
        c1= *(p1+7);
        EEPROM_Write(0x0037, c1);Delay_ms(20);
        AnNeuf=(c1-48)*10;
        c1= *(p1+8);
        EEPROM_Write(0x0038,c1);Delay_ms(20);
        AnNeuf=AnNeuf+ c1-48;
      }
      else
         UART1_Write_CText(" BAD AnNeuf value ! must be in the range 21 .. 98");
      p1=0;
     }
     // Plage Luminosit Minimale -> PLM=16:06<CR>  entre 16H00 du soir et 4H du matin
      p1= strstr(buffer1,"PLM=");  // p1 pointer result
      if(  (p1>0)&& (strlen(buffer1)>=9))
      {
        *(p1+9)=0;
         UART1_Write_CText(" Old = ");
         Read_Msg_Eeprom(0x0020,CRam1) ;
        l=isdigit(*(p1+4))+ isdigit(*(p1+5))+isdigit(*(p1+7))+isdigit(*(p1+8));
        k=(*(p1+4)-48) *10+ *(p1+5)-48;
        m=(*(p1+7)-48) *10+ *(p1+8)-48;
        if ((l==4) && (k>=15) && (k<24) && (m>3) && (m<=11))
          {
             MaxHour=k;
             c1=*(p1+4);
             EEPROM_Write(0x0024, c1);             //PLM=18:06
             c1=*(p1+5);
             EEPROM_Write(0x0025, c1);
             Delay_ms(25);
             MinHour=m;
             c1=*(p1+7);
             EEPROM_Write(0x0027, c1);
             Delay_ms(25);
             c1=*(p1+8);
             EEPROM_Write(0x0028, c1);
             Delay_ms(25);
             UART1_Write_CText(" New = ");
             Read_Msg_Eeprom(0x0020,CRam1) ;
            // UART1_Write_Text(CRam1);
            }
         else
             UART1_Write_CText(" BAD PLM values! must be from [15.. 23 ] to [ 4 .. 11 ]");
        CRLF1();
        p1=0;
       }
       p1=0;
     }
   }
 }


/*

 Presentation :
 Langage  Mikroc V 7.60
 MCU : 18F252
 Directory : C:\_MikroC\_MesProjets_MikroC8F252_Msg_Defil_8_Matrices_V
 Projet : Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi
 Source : Message_Defilant_8xMax7219_Matrices_V_18F252_2020_01.c
 Config Bits P18F252_Q_10MHz.cfgsch
 SPI1 Softw -> MAX7219, I2C1 HW -> DS1307, UART1 1900,8,N,1, OWS->DS18B20
 Power Supply 5V
 EEPROM :..._EEPROM.ihex
 8 Matrices 8x8 raccordement vertical HAUT vers Bas sur MAX7129
 Saisir un nouveau Msg avec le terminal via Msg=

 Clock initiale in  =20000  Khz
 Recup Parametres en Eeeprom PIC :
Speed=30
Rep=04
PLM=19:05
AnNeuf=21

Test reg. DS18B20
Family Code : 28 ID1= AA0D82381401  CRC= CD
Init SPI Software  RC2 (SCK), RC1 (SDO,) et RC0 (CS)
 Clear Matrice 8x 8x8
Init I2C2 (RC3=SCL et RC4=SDA )400Khz
 Init RTC DS1307
 Re-Lecture RTC
 DS1307 Date : 04-01-20 Time: 15:55:01


 Display <01234567> sur 8 matrices Leds
 Cpt=   0
 Date &t1 Now = 01-01-20 00:07:12 1577837232
 Date &T2  =  1609459200
 Difference = 31621968  soit => 33616 ->  8783 Heures
 18.68C
U;04;01;20;15;48;05#

04
01
20
15
48

Ecriture dans DS1307... OK

 RTC UpDated
New DS1307 Date :04-01-20 New Time: 15:48:00
 Cpt=   1
 Date &t1 Now = 04-01-20 15:48:09 1578152889
 Date &T2  =  1609459200
 Difference = 31306311  soit => 45639 ->  8696 Heures
 18.68C

  Cpt=   6
 Date &t1 Now = 01-01-20 00:01:05 1577836865
 Date &T2  =  1609459200
 Difference = 31622335  soit => 33983 ->  8783 Heures
U;04;01;20;14;23;05#
 0.00C

04
01
20
14
23

Ecriture dans DS1307... OK

 RTC UpDated
New DS1307 Date :04-01-20 New Time: 14:23:00
 Cpt=   7
 Date &t1 Now = 04-01-20 14:23:10 1578147790
 Date &T2  =  1609459200
 Difference = 31311410  soit => 50738 ->  8697 Heures
 
 
===============================================================

0 1 mikroCPIC1618.exe -MSF -DBG -pP18F252 -RA -C -DL -O11111014 -fo20 -EH"^C
C:\_MikroC\_MesProjets_MikroC\_18F252_Msg_Defil_8_Matrices_V\Message_Defilant_8xMax7219_Matrices_V_18F252_Eeprom.ihex" -N"^C
C:\_MikroC\_MesProjets_MikroC\_18F252_Msg_Defil_8_Matrices_V\Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_18F252_Msg_Defil_8_Matrices_V\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\_18F252_Msg_Defil_8_Matrices_V\" "Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_Conversions.mcl" "
_Lib_Time.mcl" "
_Lib_OneWire.mcl" "
_Lib_SoftSPI.mcl" "
_Lib_EEPROM_256.mcl" "
_Lib_I2C_c34.mcl" "
_Lib_UART_c67.mcl"
0 1139 Available RAM: 1515 [bytes], Available ROM: 32768 [bytes]
0 122 Compilation Started P18F252.c
1022 123 Compiled Successfully P18F252.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
0 122 Compilation Started Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
0 1004 interrupt handler (Interrupt_High at 0x0008) Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
755 1163 Variable 'i' has been declared, but not used Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
841 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
842 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
843 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
844 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
845 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
846 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
847 1506 Implicit conversion of pointer to int Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
964 1163 Variable 'jj' has been declared, but not used Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
1026 1163 Variable 'ADDR' has been declared, but not used Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
1049 1509 Generated baud rate is 19231 bps (error = 0.16 percent) Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
1614 123 Compiled Successfully Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
590 1164 Variable 'c1' has been eliminated by optimizer Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
967 1164 Variable 'Signe' has been eliminated by optimizer Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
1026 1164 Variable 'N' has been eliminated by optimizer Message_Defilant_8xMax7219_Matrices_V_18F252_2020_04.c
0 127 All files Compiled in 531 ms
0 1144 Used RAM (bytes): 1032 (68%)  Free RAM (bytes): 483 (32%) Used RAM (bytes): 1032 (68%)  Free RAM (bytes): 483 (32%)
0 1144 Used ROM (bytes): 21766 (66%)  Free ROM (bytes): 11002 (34%) Used ROM (bytes): 21766 (66%)  Free ROM (bytes): 11002 (34%)
0 125 Project Linked Successfully Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi
0 128 Linked in 250 ms
0 129 Project 'Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi' completed: 1156 ms
0 103 Finished successfully: 04 janv. 2020, 15:45:05 Message_Defilant_8xMax7219_Matrices_V_18F252.mcppi

*/